unit HTML_Input;

interface

uses Classes, SysUtils, ISAPI;

procedure GetInputString(const ECB: TEXTENSION_CONTROL_BLOCK; var Input: string);
procedure ParseHTMLInput(const Input: string; InputList: TStrings);
function  EncodeEscapes(Input: string): string;


implementation

uses TraceUnit;

procedure GetInputString(const ECB: TEXTENSION_CONTROL_BLOCK; var Input: string);
var
   tmp : string;
begin
   // TODO:  Fix this later. This assumes that cbAvailable = cbTotalBytes
   Input := PChar(ECB.lpbData);
   tmp := ECB.lpszQueryString;
   Input := Input + tmp;
   if ECB.cbAvailable <> ECB.cbTotalBytes then
      raise Exception.Create('Did not read all the bytes!');
end;

function EncodeEscapes(Input: string): string;
var
   i : integer;
   t : string;
begin
   t := '';
   for i := 1 to Length(Input) do begin
      if Input[i]=' ' then begin
         t := t + '+';
         continue;
      end;
      if not (Input[i] in ['a'..'z', 'A'..'Z', '0'..'9', '_']) then begin
         t := t + Format('%%%0.2x', [Ord(Input[i])]);
         continue;
      end;
      t := t + Input[i];
   end;
   Result := t;
end;

procedure DecodeEscapes(var s: string);
var
   New    : string;
   hexstr : string;
   c      : byte;
   i      : integer;
begin
   i := 1;
   repeat
      if s[i]='+' then begin
         New := New + ' '
      end else if s[i]='%' then begin
         hexstr := Copy(s, i+1, 2);
         c := StrToInt('$'+hexstr);
         New := New + char(c);
         i := i + 2;
      end else begin
         New := New + s[i]
      end;
      i := i + 1;
   until i > Length(s);

   s := New;
end;


function TrimBefore(var s: string; Search: char): string;
var
   p : integer;
begin
   p := Pos(Search, s);
   if p=0 then begin
      Result := s;
      s := '';
   end else begin
      Result := Copy(s, 1, p-1);
      s := Copy(s, p+1, Length(s));
   end;
end;

procedure ParseHTMLInput(const Input: string; InputList: TStrings);
var
   tmp      : string;
   ValSet   : string;
begin
   // Trim off the trailing CR/LF if there is one
   tmp := Input;
   if Copy(Input, Length(Input)-1, 2) = #13#10 then
      tmp := Copy(Input, 1, Length(Input)-2);
   // TRACE('Parsing HTML Input = %s', [tmp]);

   repeat
      ValSet := TrimBefore(tmp, '&');
      if ValSet<>'' then begin
         DecodeEscapes(ValSet);
         InputList.Add(ValSet);
         // TRACE('ValSet = %s', [ValSet]);
      end;
   until ValSet='';
end;


end.
