unit TabSet;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  GenericTableSet, Menus, StdCtrls, ExtCtrls, DBTables, TableUtils,
  ComCtrls;

type
  TTableSetForm = class(TGenericTableSetForm)
    EmptyAllTables1: TMenuItem;
    StatusBar1: TStatusBar;
    procedure FormShow(Sender: TObject);
    procedure EmptyAllTables1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure EmptyTable(Table: TTable);
    procedure  TableStatus(Sender: TObject; const Msg: string; LastOperation: boolean); override;
  end;

var
  TableSetForm: TTableSetForm;

implementation

uses Pool_Mod_Unit;

{$R *.DFM}

procedure TTableSetForm.FormShow(Sender: TObject);
begin
   TableSet.DataGroup := Pool_Module;
   TableSet.OpenTables;
   inherited;
   TableCombo.ItemIndex := TableCombo.Items.IndexOf('Games');
   TableComboChange(nil);
end;

procedure TTableSetForm.EmptyAllTables1Click(Sender: TObject);
begin
   ForEachTableIn(Pool_Module, EmptyTable);
end;

procedure TTableSetForm.EmptyTable(Table: TTable);
begin
   Table.Active := False;
   Table.Exclusive := True;
   Table.EmptyTable;
   Table.Active := True;
end;

procedure TTableSetForm.TableStatus(Sender: TObject; const Msg: string; LastOperation: boolean); 
begin
   inherited;
   StatusBar1.Panels[0].Text := Msg;
   StatusBar1.Update;
end;

end.
